#!/usr/bin/env python3


import os.path
import json
# from simple_term_menu import TerminalMenu
import subprocess
import shutil
from shutil import which
import sys
import unittest
import time

class bcolors:
  HEADER = '\033[95m'
  OKBLUE = '\033[94m'
  OKCYAN = '\033[96m'
  OKGREEN = '\033[92m'
  WARNING = '\033[93m'
  FAIL = '\033[91m'
  ENDC = '\033[0m'
  BOLD = '\033[1m'
  UNDERLINE = '\033[4m'

def print_warning(to_print):
  print(bcolors.WARNING + to_print + bcolors.ENDC)
  
def print_ok(to_print):
  print(bcolors.OKGREEN + to_print + bcolors.ENDC)

def print_fail(to_print):
  print(bcolors.FAIL + to_print + bcolors.ENDC)

  
package_json = """{
  "name": "testing",
  "version": "0.1.0",
  "private": true,
  "dependencies": {
    "@testing-library/jest-dom": "^5.11.4",
    "@testing-library/react": "^11.1.0",
    "@testing-library/user-event": "^12.1.10",
    "react": "^17.0.2",
    "react-dom": "^17.0.2",
    "react-scripts": "4.0.3",
    "web-vitals": "^1.0.1"
  },
  "scripts": {
    "start": "react-scripts start",
    "build": "react-scripts build",
    "test": "react-scripts test",
    "eject": "react-scripts eject"
  },
  "eslintConfig": {
    "extends": [
      "react-app",
      "react-app/jest"
    ]
  },
  "browserslist": {
    "production": [
      ">0.2%",
      "not dead",
      "not op_mini all"
    ],
    "development": [
      "last 1 chrome version",
      "last 1 firefox version",
      "last 1 safari version"
    ]
  }
}
"""

# https://medium.com/how-to-react/config-eslint-and-prettier-in-visual-studio-code-for-react-js-development-97bb2236b31a
class Testing(unittest.TestCase):
  def test_package_json_lint(self):
    print("Check if 'npm run lint' command exists")
    print_warning('Expecting "lint": "eslint src/** index.js --ext js --ext jsx" in package.json')
    
    with open('testing_project/package.json') as json_file:
      json_object = json.load(json_file)
      lint_value = ""
      try:
        lint_value = json_object['scripts']['lint']
      except KeyError:
        pass
      self.assertEqual(lint_value, "eslint src/** index.js --ext js --ext jsx")
      
  def test_plugins_installed(self):
    pass
  
  def test_extends_added(self):
    pass
  
  def check_vscode_settings(self):
    pass
    
  # husky + eslint + precise_commit
  def commit_fails_if_bad_indented(self):
    pass
  
  # checks eslint and prettier
  
  def check_gitlab_ci(self):
    pass
  
  # check commitizen installed globally
  # commitizen init cz-emoji-azot --save-dev --save-exact --force
  def check_git_cz(self):
    pass
  
  # npm install --save-dev husky
  # npx husky install
  
  # npm set-script prepare "husky install"


  def check_husky(self):
    pass
  
  # npm install --save-dev prettier be-pretty
  # npm set-script pretty "be-pretty formatAll"
  
  # npx husky add .husky/commit-msg 'npm run pretty'

  def precise_commit(self):
    pass
   

  # npm install --save-dev commitlint commitlint-config-azot
  # echo "module.exports = {extends: ['azot']}" > commitlint.config.js
  # npx husky add .husky/commit-msg 'npx --no-install commitlint --edit "$1"'

  def check_commit_lint(self):
    pass
  
  def add_commit_retry(self):
    pass
  
    
    
    
  def __del__(self):
    print_ok("Deleting the test react project")
    # shutil.rmtree("testing_project") # comment this line to keep the testing folder after the tests

# check if cra is installed

def check():
  if which("create-react-app") is None:
    print_fail("You need to install create-react-app to run this script")
    exit(1)
  
def init():
  print("Installing the testing folder")
  try:
    os.mkdir("testing_project")
  except:
    print_fail("Failed to create the testing folder")
  f = open("testing_project/package.json", "w")
  f.write(package_json)
  f.close()
  os.system("cd testing_project && ../../install.py && cd ..")
    
    
def main():
  init()
  unittest.main()

if __name__ == "__main__":
  main()